"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:dragonfly/c1' }"

"{ NameSpace: DragonFly }"

SharedPool subclass:#C1LLVMMTypes
	instanceVariableNames:''
	classVariableNames:'TyInstance TyInstanceFieldIndexClass TyInstanceFieldIndexSize
		TyInstanceFieldIndexSpace TyInstanceFieldIndexFlags
		TyInstanceFieldIndexAge TyInstanceFieldIndexHashLow TyOBJ
		TyInlineCache TyInlineCacheIndexFunc TyInlineCacheIndexClass
		TyInlineCacheIndexLineNo TyInlineCachePtr TyOBJFUNC TyOBJFUNCs'
	poolDictionaries:''
	category:'DragonFly-C1'
!

!C1LLVMMTypes class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.

"
! !

!C1LLVMMTypes class methodsFor:'initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."

    "/ please change as required (and remove this comment)

    TyInstance := LLVMType named: '__instance'.
    TyOBJ := TyInstance pointer.
    TyInstance elementTypes: {
        TyOBJ.                      "/ o_class
        LLVMType int32.             "/ o_size
        LLVMType int8.              "/ o_space
        LLVMType int8.              "/ o_flags
        LLVMType int8.              "/ o_age
        LLVMType int8.              "/ o_hashLow
    }.
    TyInstanceFieldIndexClass := 0.
    TyInstanceFieldIndexSize := 1.
    TyInstanceFieldIndexSpace := 2.
    TyInstanceFieldIndexFlags := 3.
    TyInstanceFieldIndexAge := 4.
    TyInstanceFieldIndexHashLow := 5.

    TyInlineCache := LLVMType named: 'inlineCache'.
    TyInlineCachePtr := TyInlineCache pointer.
    TyOBJFUNC := LLVMType function: {
        TyOBJ.                      "/ self
        TyOBJ.                      "/ selector
        TyOBJ.                      "/ searchClass or nil
        TyInlineCachePtr .          "/ pIlc
    } varargs: true returning: TyOBJ.

    TyInlineCache elementTypes: {
        TyOBJFUNC pointer .         "/ ilc_func
        TyOBJ.                      "/ ilc_class
        TyInlineCachePtr .          "/ ilc_link
        TyOBJ .                     "/ ilc_lineNo
        LLVMType char pointer .     "/ ilc_poly
    }.
    TyInlineCacheIndexFunc := 0.
    TyInlineCacheIndexClass := 1.
    TyInlineCacheIndexLineNo := 3.

    TyOBJFUNCs := {
        "/ 0 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
        } returning: TyOBJ .
        "/ 1 args 
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ .
        } returning: TyOBJ .
        "/ 2 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ .
        } returning: TyOBJ .
        "/ 3 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ .
        } returning: TyOBJ .
        "/ 4 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ .
        } returning: TyOBJ .
        "/ 5 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ .
        } returning: TyOBJ .
        "/ 6 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ .
        } returning: TyOBJ .
        "/ 7 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ .
        } returning: TyOBJ .
        "/ 8 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . 
        } returning: TyOBJ .
        "/ 9 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . 
        } returning: TyOBJ .
        "/ 10 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . 
        } returning: TyOBJ .
        "/ 11 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . 
        } returning: TyOBJ .
        "/ 12 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . 
        } returning: TyOBJ .
        "/ 13 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . 
        } returning: TyOBJ .
        "/ 14 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ .
        } returning: TyOBJ .
        "/ 16 args
        LLVMType function: {
            TyOBJ.                      "/ self
            TyOBJ.                      "/ selector
            TyOBJ.                      "/ searchClass or nil
            TyInlineCachePtr .          "/ pIlc
            TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . TyOBJ . 
        } returning: TyOBJ .
    }

    "Modified: / 20-04-2016 / 19:57:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1LLVMMTypes class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !


C1LLVMMTypes initialize!
